export declare const ATTRIBUTE_TYPE_TO_COMPONENTS: {
    SCALAR: number;
    VEC2: number;
    VEC3: number;
    VEC4: number;
    MAT2: number;
    MAT3: number;
    MAT4: number;
};
export declare const ATTRIBUTE_COMPONENT_TYPE_TO_ARRAY: {
    5120: Int8ArrayConstructor;
    5121: Uint8ArrayConstructor;
    5122: Int16ArrayConstructor;
    5123: Uint16ArrayConstructor;
    5125: Uint32ArrayConstructor;
    5126: Float32ArrayConstructor;
};
type GLTFAnimationProps = {
    name: string;
    startTime?: number;
    playing?: boolean;
    speed?: number;
    channels?: any;
};
declare class GLTFAnimation {
    name: string;
    startTime: number;
    playing: boolean;
    speed: number;
    channels: any;
    constructor(props: GLTFAnimationProps);
    animate(timeMs: number): void;
}
export declare class GLTFAnimator {
    animations: GLTFAnimation[];
    constructor(gltf: any);
    /** @deprecated Use .setTime(). Will be removed (deck.gl is using this) */
    animate(time: number): void;
    setTime(time: number): void;
    getAnimations(): GLTFAnimation[];
}
export {};
//# sourceMappingURL=gltf-animator.d.ts.map